# -*- coding: UTF-8 -*-
import os
import sys

'''
return : 0       1       2        -1
         ok     err      pending  no gpu
'''


LOGPATH = "C:\Users\Public\Documents\NvidiaLogging\Log.NVDisplay.Container.exe.log"

def if_gpu():
    if os.access(LOGPATH, os.F_OK):
        return True
    else:
        return False

def get_LicenseInterval():
    lines = os.popen('reg query "HKEY_LOCAL_MACHINE\SOFTWARE\NVIDIA Corporation\Global\GridLicensing"').readlines()
    if not lines:
        print(-1)
        sys.exit()

    LicenseInterval = 1440
    for line in lines:
        line = line.strip('\r\n').strip()
        if line.startswith("LicenseInterval"):
            LicenseInterval = int(line.split()[-1])
            break

    return LicenseInterval

def check_heartbeat(interval):
    lastHeartbeatLog = ""
    with open(LOGPATH, 'r') as fd:
        for line in fd:
            if ("Failed server communication" in line) or ("License renewed successfully" in line) or ("License acquired successfully" in line):
                lastHeartbeatLog = line

    if not lastHeartbeatLog:
        return 2
    elif "Failed server communication" in lastHeartbeatLog:
        return 1
    else:
        return 0
             

if __name__ == '__main__':
    #get_LicenseInterval()
    if not if_gpu():
        print(-1)
    else:
        print(check_heartbeat(0))
 
