# -*- coding: UTF-8 -*-
import os
import sys
import urllib2

'''
URLError
URLError可能产生的原因：

网络无连接，即本机无法上网
连接不到特定的服务器
服务器不存在
'''

'''
return :
-1           : cmd not found
-2           : cmd err
0            : ok
1            :err

'''

regeditName={'primary':['ServerAddress', 'ServerPort'],
             'backup':['BackupServerAddress', 'BackupServerPort']}

regeditDefault={'primary':['169.254.169.254', '7070'],
                'backup':['169.254.169.254', '7071']}

LOGPATH = "C:\Users\Public\Documents\NvidiaLogging\Log.NVDisplay.Container.exe.log"

def if_gpu():
    if os.access(LOGPATH, os.F_OK):
        return True
    else:
        return False


# return [serverAddr, serverPort]

def get_serverInfo(PRIorBAC='primary'):
    lines = os.popen('reg query "HKEY_LOCAL_MACHINE\SOFTWARE\NVIDIA Corporation\Global\GridLicensing"').readlines()
    if not lines:
        print(-2)
        sys.exit()

    serverAddr = regeditDefault[PRIorBAC][0]
    serverPort = regeditDefault[PRIorBAC][1]
    
    for line in lines:
        line = line.strip('\r\n').strip()
        if line.startswith(regeditName[PRIorBAC][0]):
            serverAddr = line.split()[-1]
        elif line.startswith(regeditName[PRIorBAC][1]):
            serverPort = line.split()[-1]
        else:
            continue
            

    return [serverAddr, serverPort]


def check_licenseNetwork(licenseURL):
    try:
        urllib2.urlopen(licenseURL, timeout=3)
    except urllib2.URLError ,e:
        if "Not Found" == e.reason:
            return 0
        else:
            return 1


if __name__ == '__main__':
    if (len(sys.argv) != 2) or (sys.argv[1] not in regeditName):
        print("arg err")
        sys.exit()
    
    if not if_gpu():
        print(-1)
    else:
        serverAddr,serverPort = get_serverInfo(sys.argv[1])
        licenseURL = 'http://%s:%s/'%(serverAddr, serverPort)
        print(check_licenseNetwork(licenseURL))
