# -*- coding: UTF-8 -*-

import time
import os
import psutil
import platform

SLEEPTIME = 2

def get_diskusage():
	disks=os.popen('wmic diskdrive get serialnumber,deviceid')
	disks_info={}
	for diskinfo in disks.read().split('\r\n'):
		if not (diskinfo.startswith('DeviceID') or diskinfo == ''):
			li = diskinfo.split(' ')
			while '' in li:
				li.remove('')
			disks_info.update({li[1].upper(): li[0][4:]})
	return disks_info
	
def get_current_serialnumber():
	serialnumber=None
	pid = os.getpid()
	ppid_command = 'wmic process where processid=%s get ParentProcessId'%pid
	ppid = int(os.popen(ppid_command).read().split('\r\n')[1])
	
	pppid_command = 'wmic process where processid=%s get ParentProcessId'%ppid
	pppid = int(os.popen(pppid_command).read().split('\r\n')[1])
	
	CommandLine = 'wmic process where processid=%s get CommandLine'%pppid
	command_info = os.popen(CommandLine).read().split('\r\n')[1]
	if command_info != None:
		if command_info.find("#") != -1:
			serialnumber=command_info.split('#')[1].split('.')[0]
	return serialnumber

def disk_write_requests(serialnumber):
	tm = time.time()
	if serialnumber == None:
		perdisk_info = psutil.disk_io_counters()
		write_count = perdisk_info.write_count
	else:
		perdisk_info = psutil.disk_io_counters(perdisk=True)
		disks = get_diskusage()
		for disk in perdisk_info.keys():
			if disks[serialnumber] == disk.upper():
				write_count = perdisk_info[disk].write_count
	return 	tm,write_count
	
def rate():
	serialnumber = get_current_serialnumber()
	start_time,start_requests = disk_write_requests(serialnumber)
	time.sleep(SLEEPTIME)
	end_time,end_requests = disk_write_requests(serialnumber)
	interval = end_time - start_time
	write_requests = end_requests - start_requests
	if interval is 0:
		print(0.0)
	else:
		rate = round(float(write_requests/interval),1)
		print(rate)

if __name__ == '__main__':
	rate()
	