# -*- coding: UTF-8 -*-

'''
nvidia-smi -L
GPU 0: GeForce 940MX (UUID: GPU-c26f0b00-e5e2-e3e1-8287-d806fece4c98)
'''


import os
import sys
import json


CMDPATH = r'C:\Program Files\NVIDIA Corporation\NVSMI\nvidia-smi.exe'
def if_gpu():
    if os.access(CMDPATH, os.F_OK):
        return True
    else:
        return False

def gpu_num():
    if not if_gpu():
        return -1
       
    cmdline = '"' + CMDPATH + '"' + ' -L'
    gpuinfos=os.popen(cmdline).readlines()
    if gpuinfos:
        if not gpuinfos[0].startswith('GPU'):
            return 0
    return len(gpuinfos)

def main():
    discoverinfo = {}
    discoverinfo['data'] = []
    
    gpunum = gpu_num()
    if -1 == gpunum:
        print(json.dumps(discoverinfo))
        exit()
    
    
    for i in range(gpunum):
        discoverinfo['data'].append( {"{#GPUINDEX}":"%d"%i} )

    print(json.dumps(discoverinfo))
  
if __name__ == '__main__': 
    main()