def all_upper(L1):
    return [s.upper() for s in L1]


def write_kbs(disk):
    try:
        import psutil
        try:
            disk_counter = psutil.disk_io_counters(perdisk=True)
            li = all_upper(disk_counter.keys())
            if disk in li:
                try:
                    id = li.index(disk)
                    diskid = disk_counter.keys()[id]
                    kb = float(disk_counter[diskid].write_bytes)/1024
                    return kb
                except KeyError:
                    return 'no '+str(disk)
            else:
                return 'no ' + str(disk)
        except AttributeError as err:
            return err
    except ImportError as err:
        return err


def rate(disk):
    try:
        import time
        try:
            start = write_kbs(disk)
            time.sleep(2)
            end = write_kbs(disk)
            write_bytes_rate = round((end-start)/2, 1)
            print(write_bytes_rate)
        except TypeError:
            print(write_kbs(disk))
    except ImportError as err:
        print(err)


def serialnumbertodeviceid(serialnumber):
    import os
    obj = os.popen('wmic diskdrive get serialnumber,deviceid')
    dic = {}
    for i in obj.read().split('\r\n'):
        if i.startswith('DeviceID') or i == '':
            continue
        else:
            li = i.split(' ')
            while '' in li:
                li.remove('')
            dic.update({li[1]: li[0][4:]})
    try:
        deviceid = dic[serialnumber]
        return deviceid
    except TypeError:
        return 'no '+serialnumber


if __name__ == '__main__':
    import sys
    if len(sys.argv) == 2:
        serialnumber = sys.argv[1]
        try:
            deviceid=serialnumbertodeviceid(serialnumber)
            rate(deviceid)
        except KeyError:
            print('input disk serialnumber is wrong')
    else:
        print('input disk serialnumber is wrong ')
