# -*- coding: UTF-8 -*-

import os
import re
import shutil
import platform
conf_file_dir = 'C:\\Windows\\ctcm\\conf'
error_disk={'error_disk':[]}

def get_uuid():
    uuid = None
    uuid_command = 'wmic csproduct list full'
    info = os.popen(uuid_command).readlines()
    for i in info:
        if not i.startswith('UUID'):
            continue
        else:
            uuid = i[5:-2].split('\n')[0]
    return uuid.lower()

def get_disks():
    disks_command = 'wmic diskdrive get serialnumber,deviceid'
    disks_info = os.popen(disks_command).readlines()
    disks = {}
    for info in disks_info:
        info = info.strip()
        if (info.startswith('DeviceID') or info == ''):
            continue
        else:
            li = info.split(' ')
            while '' in li:
                li.remove('')
            try:
                disks.update({li[1].upper(): li[0][4:]})
            except:
                error_disk['error_disk'].append(li)
    return disks

def get_ctcm_agentds_services():
    services_command = 'sc query state= all'
    services_info = os.popen(services_command).read().split('\n')
    services = [service[14:] for service in services_info if service.startswith('SERVICE_NAME')]
    ctcm_services = [service for service in services if service.startswith('Ctcm')]
    return ctcm_services
    
def get_ctcm_agentds_status():
    ctcm_services = get_ctcm_agentds_services()
    ctcm_agentds_status = {}
    for ctcm_service in ctcm_services:
        ctcm_agentds_status_command = 'sc query "%s"'%(ctcm_service)
        ctcm_agentds_info = os.popen(ctcm_agentds_status_command).read()
        ctcm_agentds_status_info = ctcm_agentds_info.split('\n')[3]
        if ctcm_agentds_status_info.find('RUNNING') != -1:
            ctcm_agentds_status.update({ctcm_service:'RUNNING'})
        elif ctcm_agentds_status_info.find('STOPPED') != -1:
            ctcm_agentds_status.update({ctcm_service:'STOPPED'})
    return ctcm_agentds_status

def get_exist_disk_agentds_process():
    disks_serialnumbers=[]
    ctcm_agentds_process_cmd = 'wmic process where caption="ctcm_agentd.exe" get caption,commandline /value 2>nul'
    ctcm_agentds_process_info = os.popen(ctcm_agentds_process_cmd).readlines()
    for ctcm_agentd_process in ctcm_agentds_process_info:
        if ctcm_agentd_process.startswith('CommandLine='):
            ctcm_agentd_process = ctcm_agentd_process.strip()
            # print(ctcm_agentd_process)
            if ctcm_agentd_process.find('ctcm_agentd#') != -1:
                re_str = 'ctcm_agentd#(.*).conf'
                r = re.findall(re_str,ctcm_agentd_process)
                if len(r)!=0:
                    serialnumber=r[0]
                    if len(serialnumber)!=0:
                        disks_serialnumbers.append(serialnumber)
    return disks_serialnumbers

def replace_file_content(file,old_str,new_str):
    try:
        fr = open(file,'r')
        content = fr.readlines()
        fw = open(file,'w')
        for line in content:
            if old_str in line:
                new_line = line.replace(old_str,new_str)
            else:
                new_line = line
            fw.write(new_line)
    except IOError:
        pass

# 可能是这里的问题
def modify_agentconf():
    base_srcconf = conf_file_dir+'\\ctcm_agentd.conf'
    base_log_conf = 'LogFile=c:\\Windows\\ctcm_agentd'
    base_log_file = base_log_conf + '.log'
    serialnumbers = get_disks().keys()
    uuid = get_uuid()
    for serialnumber in serialnumbers:
        shutil.copy(base_srcconf,'%s\\ctcm_agentd#%s.conf'%(conf_file_dir,serialnumber))
        replace_file_content('%s\\ctcm_agentd#%s.conf'%(conf_file_dir,serialnumber),base_log_file,'%s#%s.log'%(base_log_conf,serialnumber))
        replace_file_content('%s\\ctcm_agentd#%s.conf'%(conf_file_dir,serialnumber),'Hostname=%s'%(uuid),'Hostname=%s'%(serialnumber))
        replace_file_content('%s\\ctcm_agentd#%s.conf'%(conf_file_dir,serialnumber),'HostMetadata=windows_server','HostMetadata=windows_disk')
        replace_file_content('%s\\ctcm_agentd#%s.conf'%(conf_file_dir,serialnumber),'# StartAgents=3','StartAgents=0')
        
def get_agentconf_files():
    modify_agentconf()
    files = os.listdir(conf_file_dir)
    conf_name = [file for file in files if os.path.isfile('%s\\%s'%(conf_file_dir,file))]
    path = ['%s\\%s'%(conf_file_dir,file) for file in files]
    conf_files = [file for file in path if os.path.isfile(file)]
    conf = dict(zip(conf_name,conf_files))
    return conf

def start_ctcm_agentds(conf_file):
    install_dir = 'C:\\Windows\\ctcm\\bin'
    if platform.architecture()[0] == '32bit':
        os_type = 'win32'
    else:
        os_type = 'win64'
    if '#' in conf_file:
        start_ctcm_agentds_command = '%s\\%s\\ctcm_agentd -m -c %s -s'%(install_dir,os_type,conf_file)
    else:
        start_ctcm_agentds_command = '%s\\%s\\ctcm_agentd -c %s -s'%(install_dir,os_type,conf_file)
    os.popen(start_ctcm_agentds_command)
    
def stop_ctcm_agentds(conf_file):
    install_dir = 'C:\\Windows\\ctcm\\bin'
    if platform.architecture()[0] == '32bit':
        os_type = 'win32'
    else:
        os_type = 'win64'
    if '#' in conf_file:
        stop_ctcm_agentds_command = '%s\\%s\\ctcm_agentd -m -c %s -x'%(install_dir,os_type,conf_file)
    else:
        stop_ctcm_agentds_command = '%s\\%s\\ctcm_agentd -c %s -x'%(install_dir,os_type,conf_file)
    os.popen(stop_ctcm_agentds_command)
    
def install_ctcm_agentds(conf_file):
    agentconf_files = get_agentconf_files()
    if conf_file not in agentconf_files.values():
        modify_agentconf()
    install_dir = 'C:\\Windows\\ctcm\\bin'
    if platform.architecture()[0] == '32bit':
        os_type = 'win32'
    else:
        os_type = 'win64'
    if '#' in conf_file:
        install_ctcm_agentds_command='%s\\%s\\ctcm_agentd -m -c %s -i'%(install_dir,os_type,conf_file)
    else:
        install_ctcm_agentds_command='%s\\%s\\ctcm_agentd -c %s -i'%(install_dir,os_type,conf_file)
    os.popen(install_ctcm_agentds_command)
    start_ctcm_agentds(conf_file)

def uninstall_ctcm_agentds(conf_file):
    stop_ctcm_agentds(conf_file)
    agentconf_files = get_agentconf_files()
    if conf_file not in agentconf_files.values():
        modify_agentconf()
    install_dir = 'C:\\Windows\\ctcm\\bin'
    if platform.architecture()[0] == '32bit':
        os_type = 'win32'
    else:
        os_type = 'win64'
    if '#' in conf_file:
        uninstall_ctcm_agentds_command='%s\\%s\\ctcm_agentd -m -c %s -d'%(install_dir,os_type,conf_file)
    else:
        uninstall_ctcm_agentds_command='%s\\%s\\ctcm_agentd -c %s -d'%(install_dir,os_type,conf_file)
    os.popen(uninstall_ctcm_agentds_command)


def main():
    ctcm_agentds = get_ctcm_agentds_status()
    if 'Ctcm Agent' not in ctcm_agentds.keys():
        conf_file = '%s\\ctcm_agentd.conf'%(conf_file_dir)
        install_ctcm_agentds(conf_file)
    
    ctcm_agentds = get_ctcm_agentds_status()
    if ctcm_agentds['Ctcm Agent'] != 'RUNNING':
        conf_file = '%s\\ctcm_agentd.conf'%(conf_file_dir)
        start_ctcm_agentds(conf_file)

    old_disks_serialnumbers = get_exist_disk_agentds_process()
    new_disks = get_disks()
    new_disks_deviceids = new_disks.values()
    new_disks_serialnumbers = new_disks.keys()
    print(new_disks_serialnumbers)
    if len(error_disk['error_disk']) != 0:
        print(error_disk)
    mount_disks_serialnumbers = list(set(new_disks_serialnumbers).difference(set(old_disks_serialnumbers)))
    unmount_disks_serialnumbers = list(set(old_disks_serialnumbers).difference(set(new_disks_serialnumbers)))

    for disk_serialnumber in unmount_disks_serialnumbers:
        conf_file = '%s\\ctcm_agentd#%s.conf'%(conf_file_dir,disk_serialnumber)
        uninstall_ctcm_agentds(conf_file)

    for disk_serialnumber in mount_disks_serialnumbers:
        conf_file = '%s\\ctcm_agentd#%s.conf'%(conf_file_dir,disk_serialnumber)
        install_ctcm_agentds(conf_file)


if __name__ == '__main__':
    main()